  /////////////////////////////////////////////
 //  Association L.A.B.O. -= YoLeJedi =-  //
/////////////////////////////////////////////

#include <idc.idc>
#include "include/Disam_VM_LABO#1.idc"

///////////////////
// One-Byte Opcode
///////////////////
#define nop		      0x90
#define push_reg      0x50
#define pop_reg       0x58
#define mov_reg_reg   0xC08B  // 0x8BC0 | 00xxxyyy  (xxx=reg2, yyy=reg1)

////////////////////
// Infos macro cca
////////////////////
#define ea_cca1_base 	0x004010A2 
#define size_cca1 	    0x1B
#define ea_cca2_base 	0x004010DA
#define size_cca2 	    5
#define ea_cca3_base 	0x0040113D
#define size_cca3 	    5

///////////////////////
// Infos code de la VM
//////////////////////////////////
#define base_vm_code  0x004039CE
#define size_vm_code  0x2E0

////////////////////////
// Info section ".rdata"
//////////////////////////////
#define _rdata     0x00404020 

static main (void)
{
    auto cca_table_id, id0, id1, id2;
    auto i;
    auto base;
    auto size;

    base = 0x00401000;
    size = 0x29CE;

    /////////////////////////////////////////////
    // Crer la table d'ID
    /////////////////////////////////////////////
    cca_table_id = CreateArray ("id_macro_cca");

    //////////////////////////////////////////////////////////////
    // Crer les buffers pour enregistrer les macros cca de base
    /////////////////////////////////////////////////////////////  
    id0 = CreateArray ("macro_cca1");
    id1 = CreateArray ("macro_cca2");
    id2 = CreateArray ("macro_cca3");

    /////////////////////////////
    // remplir la table des ID
    ////////////////////////////
    SetArrayLong (cca_table_id, 0, id0);
    SetArrayLong (cca_table_id, 1, id1);
    SetArrayLong (cca_table_id, 2, id2);

    ///////////////////////////////////////
    // Sauvegarde le code des macros cca
    //////////////////////////////////////
    for (i=0;i<size_cca1;i++) SetArrayLong (id0, i, Byte (ea_cca1_base+i));
    for (i=0;i<size_cca2;i++) SetArrayLong (id1, i, Byte (ea_cca2_base+i));
    for (i=0;i<size_cca3;i++) SetArrayLong (id2, i, Byte (ea_cca3_base+i));
    
    //////////////////////////////////////////////////////////////////////////////////////

    if (SetShortPrm (INF_START_AF,(GetShortPrm (INF_START_AF) & ~AF_IMMOFF))==0)
    {
        Warning("Impossible de dsactiver la convertion 32bit Instruction to offset !");
    }		
    
    //////////////////////////////////////////////////////////////////////////////////////

    /////////////////////////////////////
    // Annuler toute l'analyse en cours
    ////////////////////////////////////
    Undefine_all (base,size);	

    /////////////////////////////
    // Nettoyer les macros cca
    ////////////////////////////  
    i = AskYN (1,"Voulez-vous nettoyer les macros cca ?");
    if (i==-1) 
    {
        CleanTable (cca_table_id);
        return;
    }
    if (i==1) clean_all_cca (base,size,cca_table_id);

    ///////////////////////////
    // Nettoyer les prfixes
    //////////////////////////
    i = AskYN (1,"Voulez-vous nettoyer les prfixes du code polymorphe ?");
    if (i==-1) 
    {
        CleanTable (cca_table_id);
        return;
    }
    if (i==1) clean_all_pref (base,size);	

    /////////////////////////////////
    // Nettoyer le code polymorphe
    ////////////////////////////////
    i = AskYN (1,"Voulez-vous nettoyer le code polymorphe ?");
    if (i==-1) 
    {
        CleanTable (cca_table_id);
        return;
    }
    if (i==1) clean_all_polym (base,size);	

    ///////////////////////////
    // Nettoyer le junk code
    //////////////////////////
    i = AskYN (1,"Voulez-vous nettoyer le jnuk code ?");
    if (i==-1) 
    {
        CleanTable (cca_table_id);
        return;
    }
    if (i==1) clean_all_junk (base,size);	
    
    ////////////////////////////////////////////////////////////////////////////////

    if (SetShortPrm (INF_START_AF,(GetShortPrm (INF_START_AF) | AF_IMMOFF))==0)
    {
        Warning("Impossible de rtablir la convertion 32bit Instruction to offset !");
    }	

    ///////////////////
    // Tout formater 
    //////////////////
    format_all (base,size);

    ///////////////////////////////////
    // Dsassembler le code de la VM 
    //////////////////////////////////
    go_disam_vm (base_vm_code,size_vm_code);

    //////////////////////////////////
    // Nettoyer et effacer les tables
    //////////////////////////////////
    CleanTable (cca_table_id);
}

static CleanTable (cca_table_id)
{
    auto i;
    
    for (i=0;i<3;i++) DeleteArray (GetArrayElement(AR_LONG, cca_table_id,i));
    DeleteArray (cca_table_id);
}

static format_all (base, size)
{
    auto ea_scan;
    /////////////////////////////////////
    // Annuler toute l'analyse en cours
    ////////////////////////////////////
    Undefine_all (base,size);

    ////////////////////////////
    // Formater tout en code
    ///////////////////////////
    ea_scan = base;
    while (ea_scan<base+size)
    {
        MakeUnkn (ea_scan,0);
        MakeCode (ea_scan);
        ea_scan = ItemEnd (ea_scan);
    }		

    ///////////////////////////
    // Fusionner tous les nop 
    //////////////////////////
    merge_nop (base,size);

    /////////////////////////////////
    // Appliquer les noms aux datas 
    ////////////////////////////////
    create_data (base,size); 

    //////////////////////////////////
    // Appliquer les noms aux labels
    /////////////////////////////////
    create_label (base,size);  	

    /////////////////////////////////////////////
    // crer la procdure de l'entry point
    // qui n'est bizarrement pas recre par IDA.
    // Dcidment, il faut tout faire ici ! :p
    //////////////////////////////////////////// 
    MakeFunction (0x00401000, 0x0040104B);   	
}

static create_label (base,size)
{  
    auto ea_scan;
    auto ea_scan_end;
    auto pcode;   
    auto buffer;

    MakeName (0x0040104B,"Traitement_Licence");
    MakeName (0x004010A0, "VM_moteur");

    // Limites de la fonction VM_moteur
    ea_scan = 0x004010A0;
    ea_scan_end = FindFuncEnd(0x004010A0);

    MakeName (ea_scan_end-8, "VM_moteur_sortie");	

    ///////////////////////////////////////////////////////
    // Dduire les noms des fonctions traitant les pcode
    //////////////////////////////////////////////////////

    while (ea_scan<ea_scan_end)
    {
        buffer = Word (ea_scan);
        if (buffer==0x3F80)          // 80 3F xx  cmp byte ptr [edi], xxh
        {
            pcode = Byte (ea_scan+2);
            ea_scan = ItemEnd(ea_scan); 
            continue;          
        }

        if (pcode!=0 && (buffer & 0xFF)==0xE8)
        {
            buffer = Dword (ea_scan+1);
            MakeName (ea_scan+5+buffer, "VM_Pcode_0x"+ltoa (pcode,16));
            pcode=0;
            ea_scan = ItemEnd(ea_scan); 
            continue;    
        }
        ea_scan = ItemEnd(ea_scan);   
    }  
} 

static create_data (base,size)
{ 
    auto buff;
    auto ea_scan;
    auto vm_table_reg;
    auto seg_selector;

    ///////////////////////////////////////////////
    // Regroupe les datas du segment _data
    ///////////////////////////////////////////////
    MakeByte (_rdata);
    MakeArray (_rdata,SegEnd(_rdata)-_rdata);   
    ////////////////////////////////////////////// 

    vm_table_reg = 0x00405000;
    MakeName (vm_table_reg, "VM_table_registres_generaux");
    MakeDword (vm_table_reg);
    MakeArray (vm_table_reg,9); 

    ///////////////////////////////////////////////////////////   
    // Scanne le code afin de valider les pointeurs 0x00405000 
    // en rfrences vers VM_table_registres_generaux 
    ///////////////////////////////////////////////////////////
    ea_scan=base;
    while (ea_scan<base+size)
    {
        buff = GetOperandValue (ea_scan,1);  
        if (buff==vm_table_reg) OpOffEx (ea_scan,1,REF_OFF32, -1,0,0);
        ea_scan= ItemEnd (ea_scan);    
    }   

    ///////////////////////////////////////////   
    // Placer les labels et formater les datas 
    ///////////////////////////////////////////

    MakeName (0x004039CE, "VM_code");  

    MakeName (0x00405034, "VM_pointeur_Instruction");
    MakeDword (0x00405034);

    MakeName (0x00405038, "VM_pointeur_pile");
    MakeDword (0x00405038);

    MakeName (0x0040503C, "VM_carry_Flag");
    MakeByte (0x0040503C);

    MakeName (0x0040503D, "VM_Zero_Flag");
    MakeByte (0x0040503D);

    MakeName (0x0040503E, "VM_pile");
    MakeDword (0x0040503E);
    MakeArray (0x0040503E,0x19);  

    MakeName (0x004050A2, "Licence_Utilisateur");
    MakeByte (0x004050A2);
    MakeArray (0x004050A2,0x13);  

    MakeName (0x004050B5, "VM_data");
    MakeByte (0x004050B5);
    MakeArray (0x004050B5,0x1B);

    MakeName (0x004050D0, "Resultat_Licence_Utilisateur");
    MakeByte (0x004050D0);
    MakeArray (0x004050D0,0x13);  

    MakeName (0x004050E3, "File_Name");
    MakeStr (0x004050E3,0);

    MakeName (0x004050F8, "Titre_MessageBox");
    MakeStr (0x004050F8,0);

    MakeName (0x00405106, "Texte_GOOD");
    MakeStr (0x00405106,0);  

    MakeName (0x0040511E, "Texte_BAD");
    MakeStr (0x0040511E,0);   

    MakeName (0x00405177, "Mask_Verification_KEY");
    MakeStr (0x00405177,0);   

} 

static clean_all_junk (base, size)
{
    auto ea_scan;
    auto buff;	
    auto dword_global_id;	

    ///////////////////////////
    // Crer le buffer global
    ///////////////////////////
    dword_global_id = CreateArray ("size_global_id");
    if ( dword_global_id == -1 )
    {
        Warning("Impossible de crer le buffer global !");
        return;
    }

    SetArrayLong (dword_global_id, 0, 0); 

    ea_scan = base;
    while (ea_scan<base+size)
    {    
        SetArrayLong (dword_global_id,0,0);	    

        clean_junk_1 (ea_scan, dword_global_id);
        buff = GetArrayElement(AR_LONG,dword_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }    

        clean_junk_2 (ea_scan, dword_global_id);
        buff = GetArrayElement(AR_LONG,dword_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }  

        clean_junk_3 (ea_scan, dword_global_id);
        buff = GetArrayElement(AR_LONG,dword_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }       
        ea_scan = ItemEnd(ea_scan); 
    }
    //////////////
    // Nettoyer
    /////////////		
    DeleteArray (dword_global_id);
}

static clean_junk_1 (ea_scan, dword_global_id)
{
    auto _byte;
    auto i;
    auto size_max; 
    auto d1,d2,w1;
    auto scan_courant;
    auto compteur_pop;

    _byte = Byte (ea_scan);
    if (_byte==nop) return;

    d1 = Dword (ea_scan+1);
    d2 = Dword (ea_scan+2);
    if (d1==0x77E73245 || d2==0x77E73245)
    {
        size_max = 0x7B;

        scan_courant = ea_scan;
        compteur_pop = 0;
        while (scan_courant<(ea_scan+size_max-0x25))
        {
            _byte = Byte(scan_courant);
            if ((_byte & pop_reg)==pop_reg) compteur_pop++;
            if (compteur_pop==3)
            {
                w1 = Word (scan_courant-2);  
                if (w1==0x2024)
                {
                    ea_scan = ea_scan-0x25;
                    size_max = scan_courant+1-ea_scan;

                    for (i=0; i<size_max; i++)
                    {
                        PatchByte (ea_scan+i, nop);
                        MakeCode (ea_scan+i);    
                    }    
                    SetArrayLong (dword_global_id,0,(size_max-0x25));  
                    return;        
                }        
            } 
            scan_courant = ItemEnd (scan_courant);
        }
    }   
}

static clean_junk_2 (ea_scan, dword_global_id)
{
    auto _byte;
    auto i;
    auto size_max; 
    auto d1,d2,b1,b2;
    auto scan_courant;
    auto compteur_pop;

    _byte = Byte (ea_scan);
    if (_byte==nop) return;
    d1 = Dword (ea_scan+1);
    d2 = Dword (ea_scan+2);
    if (d1==0x00401000 || d2==0x00401000)
    {    
        size_max = 0x50;

        scan_courant = ea_scan;
        compteur_pop = 0;
        while (scan_courant<(ea_scan+size_max-8))
        {
            _byte = Byte(scan_courant);
            if ((_byte & pop_reg)==pop_reg) compteur_pop++;
            if (compteur_pop==4)
            {
                b1 = Byte (scan_courant-3);
                b2 = Byte (scan_courant-6);

                if (b1==0x2B && b2==0x8D)
                {
                    ea_scan = ea_scan-8;

                    size_max = scan_courant+1-ea_scan;

                    for (i=0; i<size_max; i++)
                    {
                        PatchByte (ea_scan+i,nop);
                        MakeCode (ea_scan+i);    
                    }    
                    SetArrayLong (dword_global_id,0,(size_max-8));   
                    return;   
                }        
            } 
            scan_courant = ItemEnd (scan_courant);
        }
    } 
}

static clean_junk_3 (ea_scan, dword_global_id)
{
    auto _byte;
    auto i;
    auto size_max; 
    auto d1,d2,b1,b2;
    auto scan_courant;
    auto compteur_pop;

    _byte = Byte (ea_scan);
    if (_byte==nop) return;

    d1 = Dword (ea_scan+1);
    d2 = Dword (ea_scan+2);
    if (d1==0x00406560 || d2==0x00406560)
    {
        size_max = 0x55;

        scan_courant = ea_scan;
        compteur_pop = 0;
        while (scan_courant<(ea_scan+size_max-0x1D))
        {
            _byte = Byte(scan_courant);
            if ((_byte & pop_reg)==pop_reg) compteur_pop++;
            if (compteur_pop==4)
            {
                b1 = Byte (scan_courant-2);

                if (b1==0x1B)
                {
                    ea_scan = ea_scan-0x1D;
                    size_max = scan_courant+1-ea_scan;

                    for (i=0; i<size_max; i++)
                    {
                        PatchByte (ea_scan+i, nop);
                        MakeCode (ea_scan+i);    
                    }    
                    SetArrayLong (dword_global_id,0,(size_max-0x1D));  
                    return;        
                }        
            } 
            scan_courant = ItemEnd (scan_courant);
        }
    } 
}

static clean_all_polym (base, size)
{
    auto ea_scan;
    auto buff;	
    auto dword_global_id;	

    ///////////////////////////
    // Crer le buffer global
    ///////////////////////////
    dword_global_id = CreateArray ("size_global_id");
    if ( dword_global_id == -1 )
    {
        Warning("Impossible de crer le buffer global !");
        return;
    }

    SetArrayLong (dword_global_id, 0, 0); 

    ea_scan = base;
    while (ea_scan<base+size)
    {    
        SetArrayLong (dword_global_id,0,0);	  

        clean_push (ea_scan, dword_global_id);
        buff = GetArrayElement(AR_LONG,dword_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }    

        clean_pop (ea_scan, dword_global_id);
        buff = GetArrayElement(AR_LONG,dword_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }      

        clean_mov (ea_scan, dword_global_id);
        buff = GetArrayElement(AR_LONG,dword_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }       

        ea_scan = ItemEnd(ea_scan); 
    }
    /////////////
    // Nettoyer
    /////////////		
    DeleteArray (dword_global_id);
}

static clean_push (ea_scan, dword_global_id)
{
    auto _byte;
    auto i;
    auto size; 
    auto d1,w1,b1,b2;

    _byte = Byte (ea_scan);
    if (_byte==nop) return;  

    size = 0xC;
    d1 = Dword (ea_scan);

    if ((d1 & 0x00FFFFFF)==0x08EC83)
    {
        w1 = Word (ea_scan+4);
        b1 = Byte (ea_scan+9);
        b2 = Byte (ea_scan+0xB);

        if (w1 == 0x648D && b1 == 0x89 && b2 == 0x24)
        {  
            _byte = Byte (ea_scan+0xA);
            _byte = _byte & 0x38;           // mask : 00xx x000  reg
            _byte = _byte >> 3; 
            _byte = _byte | push_reg;       // opcode : push reg

            PatchByte (ea_scan,_byte);
            MakeCode (ea_scan);  

            for (i=1; i<size; i++)
            {
                PatchByte (ea_scan+i, nop);
                MakeCode (ea_scan+i);    
            }    
            SetArrayLong (dword_global_id,0,size);
        }
    }
} 

static clean_pop (ea_scan, dword_global_id)
{
    auto _byte;
    auto i;
    auto size; 
    auto d1,d2,b1,b2;

    _byte = Byte (ea_scan);
    if (_byte==nop) return;

    size = 0x11;
    d1 = Dword (ea_scan+1);

    if (d1 == 0x403568)
    {
        b1 = Byte (ea_scan-3);
        b2 = Byte (ea_scan+6);
        d2 = Dword (ea_scan+0xA);

        if (b1 == 0x8D && b2 == 0x8B && d2 == 0x0424648D)
        {  
            _byte = Byte (ea_scan+7);
            _byte = _byte & 0x38;           // mask : 00xx x000  reg
            _byte = _byte >> 3;               
            _byte = _byte | pop_reg;        // opcode : pop reg

            ea_scan = ea_scan-3;

            PatchByte (ea_scan,_byte);
            MakeCode (ea_scan);  

            for (i=1; i<size; i++)
            {
                PatchByte (ea_scan+i, nop);
                MakeCode (ea_scan+i);    
            }    
            SetArrayLong (dword_global_id,0,size-3);
        }
    }
}

static clean_mov (ea_scan, dword_global_id)
{
    auto _word;
    auto _byte;
    auto i;
    auto size_max; 
    auto d1,d2,b1,b2;
    auto scan_courant;

    _byte = Byte (ea_scan);
    if (_byte==nop) return;

    d1 = Dword (ea_scan+1);
    d2 = Dword (ea_scan+2);
    if (d1==0x5B3564FA || d2==0x5B3564FA)
    {
        b1 = Byte(ea_scan-2);
        if ((b1 & push_reg)==push_reg)
        {
            size_max = 0x21;            
            scan_courant = ea_scan;
            while (scan_courant<(ea_scan+size_max-2))
            {
                b2 = Byte(scan_courant);
                if ((b2 & pop_reg)==pop_reg)
                {            
                    b1 = b1 & (~push_reg);
                    b2 = (b2 & (~pop_reg)) << 3;  
                    _word = (b1 | b2) << 8;            
                    _word = _word | mov_reg_reg;          // mov reg2, reg1

                    ea_scan = ea_scan-2;
                    size_max = scan_courant+1-ea_scan;  

                    MakeUnkn (ea_scan,0);
                    MakeUnkn (ea_scan+1,0);
                    PatchWord (ea_scan,_word);
                    MakeCode (ea_scan);  

                    for (i=2; i<size_max; i++)
                    {
                        PatchByte (ea_scan+i, nop);
                        MakeCode (ea_scan+i);    
                    }    
                    SetArrayLong (dword_global_id,0,size_max-2);
                    return;
                } 
                scan_courant = ItemEnd (scan_courant);
            }
        }
    }
}

static clean_all_pref (base, size)
{
    auto ea_scan;

    ea_scan = base;
    while (ea_scan<base+size)
    {
        clean_prefixe (ea_scan);
        ea_scan = ItemEnd (ea_scan);
    }
}

static clean_all_cca (base, size, cca_table_id)
{
    auto ea_scan;
    auto buff;	
    auto size_global_id;	

    ////////////////////////////
    // Crer le buffer global
    ///////////////////////////
    size_global_id = CreateArray ("size_global_id");
    if ( size_global_id == -1 )
    {
        Warning("Impossible de crer le buffer global !");
        return;
    }

    SetArrayLong (size_global_id, 0, 0); 	

    ea_scan = base;
    while (ea_scan<base+size)
    {    
        SetArrayLong (size_global_id,0,size_cca1);	  
        clean_cca (ea_scan, size_global_id, GetArrayElement(AR_LONG, cca_table_id,0));
        buff = GetArrayElement(AR_LONG,size_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }

        SetArrayLong (size_global_id,0,size_cca2);
        clean_cca (ea_scan, size_global_id, GetArrayElement(AR_LONG, cca_table_id,1));
        buff = GetArrayElement(AR_LONG,size_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }

        SetArrayLong (size_global_id,0,size_cca3);
        clean_cca (ea_scan, size_global_id, GetArrayElement(AR_LONG, cca_table_id,2));		
        buff = GetArrayElement(AR_LONG,size_global_id,0);
        if (buff>0)
        {
            ea_scan = ea_scan + buff;
            continue;
        }
        ea_scan++;
    }   

    /////////////
    // Nettoyer
    /////////////	
    DeleteArray (size_global_id);

    //AnalyseArea (base, base+size);
}

static clean_prefixe (ea_scan)
{
    auto _byte;	

    _byte = Byte (ea_scan);
    if (_byte==0xF3)
    {
        _byte = Byte (ea_scan+1);
        if (_byte!=0x6C && _byte!=0x6D && _byte!=0xA4 && _byte!=0xA5 &&\
            _byte!=0x6E && _byte!=0x6F && _byte!=0xAC && _byte!=0xAD &&\
            _byte!=0xAA && _byte!=0xAB && _byte!=0xA6 && _byte!=0xA7 &&\
            _byte!=0xAE && _byte!=0xAF) PatchByte (ea_scan, nop);    
    }
    else
    {
        if (_byte==0xF2)
        {
            _byte = Byte (ea_scan+1);
            if (_byte!=0xA6 && _byte!=0xA7 && _byte!=0xAE && _byte!=0xAF) PatchByte (ea_scan, nop);    
        }
    }    
    MakeCode (ea_scan);   
}

static clean_cca (ea_scan,id_size,id_table_code)
{
    auto i;
    auto size;

    size = GetArrayElement(AR_LONG,id_size,0);
    for (i=0;i<size;i++) 
    {
        if (Byte (ea_scan+i)!=GetArrayElement(AR_LONG, id_table_code,i))
        {
            SetArrayLong (id_size,0,0);
            return;
        }
    }

    for (i=0; i<size; i++)
    {
        PatchByte (ea_scan+i, nop);	
        MakeCode (ea_scan+i);
    }	
}

static Undefine_all (base,size)
{
    auto i; 
    for (i=0;i<size;i++) MakeUnkn (base+i,0);
}

static merge_nop (base,size)
{
    auto addr_courante;
    auto flag; 

    addr_courante=base;
    flag=0;
    while (addr_courante<base+size) 
    {	
        if (Byte (addr_courante)==nop)
        {
            MakeUnkn (addr_courante,0);      
            flag++;
        }
        else
        {
            if (flag>0)
            {
                addr_courante = addr_courante-flag;
                if (flag==1)
                {
                    MakeCode (addr_courante);
                }
                else
                {
                    // SI un jmp est dj appliqu
                    if ((Byte(addr_courante-2)==0xEB && Byte(addr_courante-1)==flag)  ||
                        (Byte(addr_courante-5)==0xE9 && Dword(addr_courante-4)==flag))
                    {
                        
                        // ALORS crer simplement le tableau de nop 
                        MakeByte (addr_courante);
                        MakeArray (addr_courante,flag);
                    }
                    else
                    {
                        // SINON Appliquer un jmp au dessus du 
                        // tableau de nop avant de le crer
                        if (flag<0x00000080)
                        {
                            PatchByte (addr_courante, 0xEB);      // jmp court
                            PatchByte (addr_courante+1, flag-2);  // offset
                            MakeCode (addr_courante);
                            addr_courante = ItemEnd (addr_courante);
                            if (flag>2)
                            {            
                                MakeByte (addr_courante);
                                MakeArray (addr_courante,flag-2);
                            }            
                        }
                        else
                        {
                            PatchByte  (addr_courante, 0xE9);      // jmp long
                            PatchDword (addr_courante+1, flag-5);  // offset
                            MakeCode (addr_courante);
                            addr_courante = ItemEnd (addr_courante);
                            MakeByte (addr_courante);
                            MakeArray (addr_courante,flag-5);                      
                        }
                    }   
                }
                flag=0;
            }       
        }  
        addr_courante = ItemEnd (addr_courante);	
    }		
}
